#ifndef __Expression_H__
#define __Expression_H__
/*--------------------------------------------------------------------------
EXPRESSION.H

Basic Math Expression Calculator
Copyleft (c) 2024~2024 NCY
All rights reversed.

--------------------------------------------------------------------------*/
#include "TYPE.h"
#include "_STC8X_.h"
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
//궨
#define Pi 3.1415926535 
#define Exp 2.7182818284
#define MaxLenth 64
//#define NAN 0.0/0.0
//#define INF 1.0/0.0
//־
#define OPERATOR_INVALID 0 //Ч
#define ADD_FLAG 1 // +
#define MIN_FLAG 2 // -
#define MUL_FLAG 3 // *
#define DIV_FLAG 4 // /
#define POW_FLAG 5 // ^
#define PLEFT_FLAG 6  //  (
#define PRIGHT_FLAG 7 //  )
#define COMMA_FLAG 8  //  ,


#define FUNC_INVALID 0  //Ч
#define	SIN_FLAG 1  //sin
#define	COS_FLAG 2  //cos
#define	TAN_FLAG 3  //tan
#define	ASIN_FLAG 4  //asin
#define	ACOS_FLAG 5  //acos
#define	ATAN_FLAG 6  //atan
#define	ABS_FLAG 7  //abs
#define	SINH_FLAG 8  //sinh
#define	COSH_FLAG 9  //cosh
#define	TANH_FLAG 10 //tanh
#define LN_FLAG 11  // ln
#define	LG_FLAG 12  //lg
#define	RAND_FLAG 13  // rand
#define RANDOM_FLAG  14  //random

#define TYPE_INVALID 0  //Ч
#define TYPE_NUMBER 1   //
#define TYPE_PARAMETER 2  //ʻ֣ת沨ʽʱ滻ΪӦֵˣ
#define TYPE_OPERATOR 3  //ţ
#define TYPE_FUNCTION 4  //


#define CMP_INVALID 0   //ЧȽϽ
#define CMP_LARGER 1    //ȼa>b
#define CMP_SAME 2      //ȼa==b
#define CMP_SMALLER 3   //ȼa<b

//ĸȼ
#define PRIORITY0 0
#define PRIORITY1 1
#define PRIORITY2 2
#define PRIORITY3 3
#define PRIORITY4 4
//  '^'   '*' '/'  '+''-'   Invalid
// 4      3          2          1          0


//
//0x01:Syntax Error 0x01 ڶС 
//0x02:Syntax Error 0x02 Ųƥ
//0x03:Syntax Error 0x03 δַ 
//0x04:Syntax Error 0x04 Ч
//0x05:Syntax Error 0x05 ѧʽ
//0x06:Unkwon Error 0x06 δ֪ 
//0x07:Math Error 0x07 ѧ 


//Cal_tokenԪ
typedef struct{
	uint8_t type;
	float value;		
}Cal_Token;

/*

Cal_token.type:

type==0:Ч  invalid
--------------------------------------
type==1:  value:Ǹֵ 
--------------------------------------
type==2:/  
              u,v,w  x y z  
              value: 1 2 3  4 5 6 
--------------------------------------	   
type==3           +-*\^(),  
              value:  12345678    
--------------------------------------	           
	                1Ԫ 1Ԫ 1Ԫ  1Ԫ  1Ԫ 1Ԫ  1Ԫ 1Ԫ   1Ԫ  1Ԫ  1Ԫ 1Ԫ  0Ԫ  2Ԫ       //Ǳ!^_^ 
type==4         sin cos tan asin acos atan abs sinh cosh tanh  ln  lg  rand random 
              value: 1   2   3   4    5    6    7    8    9    10  11  12   13    14    
              a: asin acos atan abs
              s:sin sinh
              c:cos cosh
              t:tan tanh
              l:ln lg
              r:rand random 
              עrand()0~1 
                  random(a,b) b>a>0 a~b 

*/
typedef struct{
	Cal_Token token[MaxLenth];
	uint8_t Stack_Ptr;	
}Cal_Stack;
typedef struct{
	Cal_Token token[MaxLenth];
	uint8_t Array_Ptr;		
}Cal_Array;
typedef struct{
	uint8_t Str[MaxLenth];
	uint8_t Str_Ptr;
}Cal_String; 

//Stack
uint8_t Stack_IsEmpty(Cal_Stack *stk);
uint8_t Stack_Push(Cal_Stack *stk,Cal_Token Element);
uint8_t  Stack_Pop(Cal_Stack *stk);
Cal_Token Stack_Get_Top(Cal_Stack *stk);
//ErrorHandler(Uselessly...)
void ErrorHandler(uint8_t *bf);
//Working Functions
uint8_t Cal_Get_Token(Cal_String *s,Cal_Array *tk);
uint8_t Cal_cmp(Cal_Token a,Cal_Token b);
uint8_t Cal_Mid2Post(Cal_Array *Tokens,Cal_Array *Post,float *Para);
float Cal_Calculate_RPN(Cal_Array *Post,float *Para);
//User:
float Calculate_Expression(char *s,uint8_t l, float *para);
uint8_t Get_ErrorCode();
#endif